"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isPlainObject = _interopRequireDefault(require("lodash/isPlainObject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const replaceValues = (arg, values, replacers) => {
  if (Array.isArray(arg)) {
    return arg.map(item => replaceValues(item, values, replacers));
  }

  if ((0, _isPlainObject.default)(arg)) {
    return Object.keys(arg).reduce((acc, key) => _objectSpread({}, acc, {
      [key]: replaceValues(arg[key], values, replacers)
    }), {});
  }

  if (values.includes(arg)) {
    return replacers[values.indexOf(arg)];
  }

  return arg;
};

var _default = transformer => resolver => async (_, args, ctx, info) => {
  const keys = [];
  const promises = [];
  let finalArgs = await transformer(_, args, ctx, info, {
    resolve: promise => {
      const key = Symbol(keys.index);
      keys.push(key);
      promises.push(promise);
      return key;
    }
  });

  if (promises.length) {
    finalArgs = replaceValues(finalArgs, keys, (await Promise.all(promises)));
  }

  return resolver(_, finalArgs, ctx, info);
};

exports.default = _default;