"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ms = _interopRequireDefault(require("ms"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const isEmpty = value => value === undefined || value === null;

var _default = getCacheConfig => resolver => async (_, args, ctx, info) => {
  let config = typeof getCacheConfig === 'function' ? await getCacheConfig(_, args, ctx, info) : getCacheConfig;

  if (typeof config === 'string') {
    const serializedArgs = Object.keys(args).length ? JSON.stringify(args, Object.keys(args).sort()) : '';
    config = {
      id: `${config}${serializedArgs ? `:${serializedArgs}` : ''}`
    };
  }

  const {
    id,
    policy: policyName,
    ttl
  } = _objectSpread({
    ttl: 0,
    policy: 'graphqlResolvers'
  }, config);

  if (!id) {
    return resolver(_, args, ctx, info);
  }

  const policy = ctx.cache.getPolicy(policyName);
  let result = await policy.get(id);

  if (isEmpty(result)) {
    result = await resolver(_, args, ctx, info);

    if (!isEmpty(result)) {
      await policy.set(id, result, typeof ttl === 'string' ? (0, _ms.default)(ttl) : ttl);
    }
  }

  return result;
};

exports.default = _default;