"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _omit = _interopRequireDefault(require("lodash/omit"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = (log = (_, args, {
  modules,
  req
}, info, data) => {
  if (modules.has('oors.logger')) {
    modules.get('oors.logger')[data.error ? 'error' : 'info'](data.message, _objectSpread({}, (0, _omit.default)(data, ['message']), {
      userId: req.user ? req.user._id : null,
      IP: req.IP
    }));
  } else {
    console.log(data);
  }
}) => message => resolver => async (_, args, ctx, info) => {
  let data;
  let result;
  let error;

  try {
    result = await resolver(_, args, ctx, info);
    data = typeof message === 'function' ? await message(_, args, ctx, info, {
      result
    }) : {
      message: message || info.fieldName,
      args,
      result
    };
  } catch (err) {
    error = err;
    data = typeof message === 'function' ? await message(_, args, ctx, info, {
      error
    }) : {
      message: message || info.fieldName,
      args,
      error
    };
  }

  if (data) {
    log(_, args, ctx, info, data);
  }

  if (error) {
    throw error;
  }

  return result;
};

exports.default = _default;