"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _apolloServer = require("apollo-server");

var _default = ({
  isValidUser = () => true,
  getUserFromContext = ctx => ctx.user,
  handleError = () => {
    throw new _apolloServer.ForbiddenError('Restricted access!');
  }
} = {}) => resolver => async (root, args, ctx, info) => {
  const user = await getUserFromContext(ctx);

  if (!user) {
    throw new _apolloServer.AuthenticationError('Not authenticated!');
  }

  const isValid = await isValidUser(root, args, ctx, info);

  if (!isValid) {
    handleError(root, args, ctx, info, user);
  }

  return resolver(root, args, ctx, info);
};

exports.default = _default;