"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _apolloServer = require("apollo-server");

var _default = (validate, message) => resolver => async (_, args, ctx, info) => {
  try {
    const isValid = await validate(_, args, ctx, info);

    if (!isValid) {
      throw new Error();
    }
  } catch (error) {
    throw new _apolloServer.UserInputError(message || error.message || 'Failed Validation!', {
      originalError: error
    });
  }

  return resolver(_, args, ctx, info);
};

exports.default = _default;