"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _apolloServer = require("apollo-server");

var _easevalidation = require("easevalidation");

var _default = (validatorOrFactory, message = 'Failed validation!') => {
  const {
    stack
  } = new Error();
  return resolver => (_, startArgs, ctx, info) => {
    let validator = validatorOrFactory;
    let args = startArgs; // eslint-disable-next-line no-underscore-dangle

    if (!validatorOrFactory.__validation__) {
      // if it's not a validator, it must be a factory function
      validator = validatorOrFactory(_, args, ctx, info);
    }

    try {
      args = (0, _easevalidation.validate)(validator)(startArgs);
    } catch (error) {
      throw new _apolloServer.UserInputError(message, {
        invalidArgs: Object.keys(error.error),
        error: (0, _easevalidation.formatError)(error),
        stack
      });
    }

    return resolver(_, args, ctx, info);
  };
};

exports.default = _default;