"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _set = _interopRequireDefault(require("lodash/set"));

var _has = _interopRequireDefault(require("lodash/has"));

var _get = _interopRequireDefault(require("lodash/get"));

var _dataloader = _interopRequireDefault(require("dataloader"));

var _invariant = _interopRequireDefault(require("invariant"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class LoadersMap {
  constructor() {
    this.loaders = {};
  }

  multiAdd(loaders, namespace) {
    Object.keys(loaders).forEach(key => {
      const {
        loader,
        options
      } = loaders[key];
      this.add(`${namespace ? `${namespace}.` : ''}${key}`, loader, options);
    });
    return this;
  }

  add(id, batchLoadFn, options) {
    (0, _invariant.default)(!(0, _has.default)(this.loaders, id), `Unable to add loader for id - ${id}! Id already exists.`);
    (0, _set.default)(this.loaders, id, [batchLoadFn, options]);
    return this;
  }

  build(path) {
    const loaders = path ? (0, _get.default)(this.loaders, path) : this.loaders;
    return Object.keys(loaders).reduce((acc, key) => _objectSpread({}, acc, {
      [key]: Array.isArray(loaders[key]) ? new _dataloader.default(...loaders[key]) : this.build(`${path ? `${path}.` : ''}${key}`)
    }), {});
  }

}

var _default = LoadersMap;
exports.default = _default;